#include "ShaderConstants.fxh"
#include "util.fxh"
#include "sky.yss"

struct PS_Input
{
float3 worldPos : WPOS;
    float4 position : SV_Position;
    float2 uv : TEXCOORD_0_FB_MSAA;
};

struct PS_Output
{
    float4 color : SV_Target;
};


  
ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{


float3 fixpos = float3(PSInput.worldPos.x,-PSInput.worldPos.yz);
fixpos.y += 0.128;

float4 light =TEXTURE_1.Sample(TextureSampler1, float2(0.0,1.0));
float timeuv1=smoothstep(0.462745,0.989235,light.r)*2.0-1.0;
float3 sunposition=SP(timeuv1);



#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE) || (VERSION < 0xa000 /*D3D_FEATURE_LEVEL_10_0*/) 
	float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
#else
	float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv);
#endif

diffuse.a=1.0;


#ifdef ALPHA_TEST
    if( diffuse.a < 0.5 )
    {
        discard;
    }
#endif



diffuse=skyrender(diffuse,normalize(fixpos),normalize(fixpos),sunposition,timeuv1);

diffuse.rgb=final(diffuse.rgb);

diffuse.a=1.0;


#ifdef IGNORE_CURRENTCOLOR
    //PSOutput.color = diffuse;
#else
    PSOutput.color = diffuse;
#endif

#ifdef WINDOWSMR_MAGICALPHA
    // Set the magic MR value alpha value so that this content pops over layers
    PSOutput.color.a = 133.0f / 255.0f;
#endif
}
