#include "ShaderConstants.fxh"
#include "util.fxh"

struct PS_Input
{
    float3 worldpos : WPOS;
    float4 position : SV_Position;
    float2 uv : TEXCOORD_0_FB_MSAA;
};

struct PS_Output
{
    float4 color : SV_Target;
};

 float rand( float2 X){ 
	return frac(cos(X.x + X.y *252.0) * 75.0);}

 float noise( float2 X){ 
    float2 A = floor(X); 
    float2 B = frac(X); 
    float2 C = pow(B,float2(2.0,2.0))*(3.0- 2.0*B); 
    float D = rand(A+float2(0.0,0.0));
    float E = rand(A+float2(1.0,0.0));
    float F = rand(A+float2(0.0,1.0));
    float G = rand(A+float2(1.0,1.0));
    float X1 = lerp( lerp(D, E, C.x),lerp(F, G, C.x),C.y);
	return X1;}




ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{

float rain=clamp(1.0-pow(FOG_CONTROL.y,5.0),0.0,1.0);//雨天检测
float night=clamp(pow(max(min(1.0-FOG_COLOR.r*1.5,1.0),0.0),1.2),0.0,1.0);//夜间检测
float sun=clamp(pow(max(min(1.0-FOG_COLOR.b*1.2,1.0),0.0),0.5)-night,0.0,1.0);//日出日落

#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE) || (VERSION < 0xa000 /*D3D_FEATURE_LEVEL_10_0*/) 
	float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
#else
	float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv);
#endif

#ifdef ALPHA_TEST
    if( diffuse.a < 0.5 )
    {
        discard;
    }
#endif

float2 po=PSInput.worldpos.xz;

float sita = atan2(po.y,po.x);
float row =length(po);
float sunlight=noise(sita*20.0+TIME)*smoothstep(0.4,0.35,row)*smoothstep(0.3,0.35,row);
//diffuse.rgb=lerp(diffuse.rgb,float3(2.0,0.0,0.0),sunlight);

if(length(PSInput.position.xyz)<0.1)diffuse.rgb=0.0;



#ifdef IGNORE_CURRENTCOLOR
    PSOutput.color = diffuse;
#else
   //PSOutput.color = CURRENT_COLOR * diffuse;
PSOutput.color = diffuse;
#endif


#ifdef WINDOWSMR_MAGICALPHA
    // Set the magic MR value alpha value so that this content pops over layers
    PSOutput.color.a = 133.0f / 255.0f;
#endif
}
